#include <stdio.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"



#include <Eigen/Dense>
#include <unsupported/Eigen/MatrixFunctions>

using namespace Eigen;

void Set_simul_param(int argc, char *argv[]);
void Make_ue_sector_object(void);
void Set_test_environment(void);
void Set_fastfading_param();
void Set_antenna_location_matrix();
void Deploy_bs_ue(void);
void Configure_sector_ue(void);
void Calculate_UE_Sector_angle(void);
void Calculate_antenna_gain(void);
void Generate_pathloss(void);
void Get_Couplingloss_CDF(void);
void Connect_UE_BS(void);
void Collect_Couplingloss(void);
void Allocate_memory(void);
void Delete_memory(void);
void Generate_LSP(void);
void Generate_SSP(void);
void Scheduling(void);

int main(int argc, char *argv[])
{
	/*
	MatrixXd a;
	MatrixXd b;

	MatrixXcd c;

	a= MatrixXd(4, 2);
	b = MatrixXd(2, 1);
	c = MatrixXcd::Zero(4, 1);

	a(0, 0) = 1;
	
	a(0, 1) = 1;
	a(1, 0) = 1;
	a(1, 1) = 1;
	a(2, 0) = 1;
	a(2, 1) = 1;

	a(3, 0) = 1;
	a(3, 1) = 1;

	b(0, 0) = 1;
	b(1, 0) = 1;

	c.imag() = PI*a*b/4;
	
	cout << a*b << endl;
	cout << c << endl;
	cout <<  c.array().exp()<< endl;

	c = c.array().exp();

	cout << c << endl;

	getchar();
	*/
	Set_simul_param(argc, argv);
	cout << "Set_simul_param" << endl;
	Set_test_environment();
	cout << "Set_test_environment" << endl;
	Set_fastfading_param();
	cout << "Set_fastfading_param" << endl;
	Set_antenna_location_matrix();
	cout << "Set_antenna_location_matrix" << endl;
	Make_ue_sector_object();
	cout << "Make_ue_sector_object" << endl;
	Allocate_memory();
	cout << "Allocate_memory" << endl;

	for (drop_idx = 0; drop_idx < num_drops; drop_idx++)
	{


		cout << "drop_idx : " << drop_idx <<"/"<<num_drops<< endl;
		
		Configure_sector_ue();
		cout << "Configure_sector_ue" << endl;
		Deploy_bs_ue();
		cout << "Deploy_bs_ue" << endl;
		Calculate_UE_Sector_angle();
		cout << "Calculate_UE_Sector_angle" << endl;
		Calculate_antenna_gain();
		cout << "Calculate_UE_Sector_angle" << endl;
		Generate_pathloss();
		
		cout << "Generate_LSP..." << endl;

		Generate_LSP();

		Connect_UE_BS();
		//Collect_Couplingloss();

		Generate_SSP();
		
		for (t = 0; t < run_times; t++)
		{
			Scheduling();
			
		}
		

	}

	//Get_Couplingloss_CDF();
	Delete_memory();
	
}


