
#include "sector.h"
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "ue.h"
#include "const.h"


/*===================================================================
FUNCTION: Sector::Sector()

AUTHOR: SJ

DESCRIPTION: Sector Object Constructor

NOTES: Currently, nothing is done when a sector is instantiated

===================================================================*/

Sector::Sector()
{
	pschedulewrite = new SCHEDULE_DECISION[num_rbs_in_1ms];
}

/*===================================================================
FUNCTION: Sector::~Sector()

AUTHOR: SJ

DESCRIPTION: Sector Object Destructor

NOTES: Currently, nothing is done

===================================================================*/
Sector::~Sector()
{
	delete pschedulewrite;
}

/*===================================================================
FUNCTION: Sector::Configure( int )

AUTHOR: SJ

DESCRIPTION: Sector object gets to know the index of itself

NOTES: More functionality may be added

===================================================================*/
void Sector::initialization(int sector_idx)
{
	ue_in_control.clear();
	
	_sector_idx = sector_idx;
	
}

void Sector::RR_scheduling()
{
	int rs_size = num_rbs_in_1ms;
	int num_rs = num_rbs_in_1ms / rs_size;
	SCHEDULE_DECISION *decision;
	decision = new SCHEDULE_DECISION[num_rs];

	if (num_rs > int(ue_in_control.size()))
	{
		num_rs = ue_in_control.size();
	}

	cout << "ue_in_control.size() : "<<int(ue_in_control.size()) << endl;
	
	for (int ind=0 ; ind< int(ue_in_control.size()) ; ind++)
	{
		cout << "ue_in_control["<< ind <<"] : " << ue_in_control[ind] << endl;
	}
	
	
	for (int rs_idx = 0; rs_idx < num_rs; rs_idx++)
	{
		decision[rs_idx].ue_selected = -1;
	}

	for (int rs_idx = 0; rs_idx < num_rs; rs_idx++)
	{
		int selected_ue;
		bool end_decision;
		do
		{
			selected_ue = (int)(Rand.u()*ue_in_control.size());

			end_decision = true;
			for (int check_idx = 0; check_idx < rs_idx; check_idx++)
			{
				if (decision[check_idx].ue_selected == ue_in_control[selected_ue])
					end_decision = false;
			}
		} while (!end_decision);
		decision[rs_idx].ue_selected = ue_in_control[selected_ue];
	}


	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		if ((int)rb_idx / rs_size < num_rs)
		{
			pschedulewrite[rb_idx] = decision[(int)(rb_idx / rs_size)];
		}
		else
		{
			pschedulewrite[rb_idx] = pschedulewrite[rb_idx - 1];
		}
	}
	for (int rb_idx = 0; rb_idx < num_rbs_in_1ms; rb_idx++)
	{
		cout << pschedulewrite[rb_idx].ue_selected << endl;
	}

	getchar();
	delete decision;
}

void Sector::PF_scheduling()
{


}






